//
// Programma che utilizza la classe List, prima versione.
//


#include <iostream.h>
#include "List2.H"
#include "CompClass3.H"


main()
{
  List<int> l1;
  List<complex> l2;

  // Lista di Complessi
  complex z1(12.13, -7.5);
  complex z2(1.414, -1.414);

  l2.Insert(z1);
  l2.Insert(z2);
  l2.Insert(1.028);

  l2.GoToFirst();	// Vado sul primo elemento

  cout << "L'elemento corrente della lista e` " << l2.Read() << endl;
  cout << "Rimuovo il dato corrente dalla lista " << l2.Delete() << endl;
  cout << "L'elemento corrente della lista e` " << l2.Read() << endl;

  // Scorro tutta la Lista in avanti
  cout << "============" << endl;
  cout << "La lista in avanti ..." << endl;
  l2.GoToFirst();
  while(!l2.IsEndOfList()) {
    cout << "Elemento " << l2.Read() << endl;
    l2.Next();
  }
  cout << "============" << endl;


  // Lista di interi


  l1.Insert(1);		// Inserisco 4 elementi
  l1.Insert(2);
  l1.Insert(3);
  l1.Insert(5);

  l1.GoToFirst();	// Vado sul primo elemento

  cout << "L'elemento corrente della lista e` " << l1.Read() << endl;
  cout << "Rimuovo il dato corrente dalla lista " << l1.Delete() << endl;
  cout << "L'elemento corrente della lista e` " << l1.Read() << endl;

  l1.Insert(7);		// Inserisco altri due elementi a partire dalla
  l1.Insert(9);		// posizione corrente

  l1.GoToEndOfList();	// Vado in fondo alla lista
  l1.Insert(11);	// Aggiungo altri 2 elementi
  l1.Insert(13);

  // Scorro tutta la Lista in avanti
  cout << "============" << endl;
  cout << "La lista in avanti ..." << endl;
  l1.GoToFirst();
  while(!l1.IsEndOfList()) {
    cout << "Elemento " << l1.Read() << endl;
    l1.Next();
  }
  cout << "============" << endl;

  cout << "Cambio l'ultimo elemento ..." << endl;
  l1.GoToEndOfList();	// Cancello l'ultimo elemento
  l1.Previous();
  l1.Write(17);
  cout << "L'elemento corrente della lista e` " << l1.Read() << endl;

  cout << "Cancello l'ultimo elemento ..." << endl;
  l1.GoToEndOfList();	// Cancello l'ultimo elemento
  l1.Previous();
  l1.Delete();

  cout << "Cancello il secondo elemento ..." << endl;
  l1.GoToFirst();	// Cancello il secondo elemento
  l1.Next();
  l1.Delete();

  // Scorro tutta la Lista a ritroso
  cout << "============" << endl;
  cout << "La lista a ritroso ..." << endl;
  l1.GoToEndOfList();
  while(!l1.IsFirst()) {
    l1.Previous();
    cout << "Elemento " << l1.Read() << endl;
  }
  cout << "============" << endl;    

  exit(0);
}
